Cribl Docs – Global llms-full.txt (Full Text for AI Agents) This file is an automatically generated concatenation of all public Cribl documentation in Markdown form. It is intended for bulk ingestion by AI agents, MCP servers, and embedding/semantic search pipelines. It is not curated, and it is not optimized for initial discovery or human reading. For global indexes and product-scoped ingestion options, see: - Global index (llms.txt, auto-generated, not curated): https://docs.cribl.io/llms.txt - Per-doc-set page indexes (llms.txt under each area, e.g. Stream): https://docs.cribl.io/stream/llms.txt - Per-doc-set llms-full.txt files (for product-scoped ingestion), for example: - https://docs.cribl.io/stream/llms-full.txt - https://docs.cribl.io/edge/llms-full.txt - https://docs.cribl.io/search/llms-full.txt - https://docs.cribl.io/lake/llms-full.txt - https://docs.cribl.io/insights/llms-full.txt - https://docs.cribl.io/copilot/llms-full.txt - https://docs.cribl.io/apps/llms-full.txt - https://docs.cribl.io/cribl-as-code/llms-full.txt - https://docs.cribl.io/guard/llms-full.txt ############################################################ # SOURCE: https://docs.cribl.io/cribl-as-code/cribl-as-code-concepts.md ############################################################ # Basic Concepts for Cribl as Code This page introduces basic Cribl concepts to provide context for Cribl as Code. For detailed information about these concepts and other Cribl resources and features, refer to the [Cribl product documentation](https://docs.cribl.io). ## Control Plane and Management Plane {#control-mgmt} Cribl distinguishes in-deployment product configuration (the control plane) from administration (the management plane). The control plane is supported in every [deployment model](#deployment-models): Cribl.Cloud, hybrid, and on-prem. The management plane is supported only in Cribl.Cloud. It is not supported for deployments that do not use Cribl.Cloud, including standalone on-prem Leaders and other fully self-hosted topologies. * Use the control plane to manage product resources, such as Worker Groups and Edge Fleets, Sources, Destinations, Pipelines, Cribl Search Datasets, and Cribl Lake storage. * Use the management plane for orchestration and administrative tasks for Organizations, Workspaces, and billing in Cribl.Cloud. For a complete description of Cribl architecture, see [The Cribl Three-Plane Model](/reference-architectures/core-arch-concepts/). ## Deployment Models (Cribl.Cloud, On-Prem, and Hybrid) {#deployment-models} Your Cribl deployment model determines where the Leader runs and whether the underlying infrastructure is Cribl-managed (Cribl.Cloud), customer-managed (on-prem), or both (hybrid). * In [Cribl.Cloud deployments](/stream/deploy-cloud), Cribl hosts and operates the Leader and the Cribl-managed parts of your footprint. You use Organizations and Workspaces to separate environments, set up access control, and configure products. * In [on-prem (self-hosted) deployments](/stream/deploy-types), you install and operate Cribl on infrastructure that you control. You run the Leader, Workers, and Edge Nodes in environments that you operate. * [Hybrid deployments](/stream/cloud-enterprise#hybrid) use a Cribl.Cloud Leader. Stream Workers and Edge Nodes run in a mix of Cribl-managed and customer-managed locations, such as your cloud accounts or data centers. For details about the architecture for each deployment model, see [Cribl.Cloud](/reference-architectures/arch-cloud-arch-planning), [on-prem](/reference-architectures/arch-onprem-planning), and [hybrid](/reference-architectures/arch-hybrid-planning). ############################################################ # SOURCE: https://docs.cribl.io/cribl-as-code/api.md ############################################################ # Cribl API The Cribl API is a RESTful API that provides a centrally managed control plane for programmatically configuring and managing Cribl resources. Developers can use the API to: - Retrieve and manage data. - Automate repetitive manual processes. - Integrate with third-party applications. - Consistently replicate environments and resources for testing, development, and deployment. The Cribl API generally follows a resource-based structure in which each endpoint corresponds with a specific Cribl resource or collection of resources. In request URLs, resource-specific paths branch off from the [base URL](#base-urls). Read the [Authentication](api-auth) page to learn how to authenticate to the Cribl API. > ##### About PATCH Requests > > In the Cribl API for the control plane, PATCH requests require a complete representation of the resource that you want to update. Endpoints that use the PATCH method do not support partial updates. Cribl removes any omitted fields when updating the resource. If you use a GET request to retrieve an existing configuration to use in the body of a PATCH request, confirm that the configuration is correct. If the existing configuration is incorrect, the updated resource may not function as expected. The [Update Configurations](update-configurations) example demonstrates how to update a Destination using the PATCH method. > > The Cribl API for the management plane does support partial updates for endpoints that use the PATCH method. {.box .warning} ## Try It Out {#try-it-out} The [API Reference](/api-reference/) is also available in Cribl at **Settings** > **Global** > **API Reference**. We recommend using the in-product API Reference because it features a **Try it out** button for each endpoint that you can use to construct and execute a `curl` command and examine the response. The in-product API Reference aligns with your environment and provides a seamless testing experience. At the top of the in-product API Reference, a **Servers** drop-down menu lists the base URLs associated with your Stream Leader and Worker Groups, Edge Fleets, and Search instance. **Try it out** commands use the base URL that you select from the **Servers** drop-down menu. The default selection in the **Servers** drop-down is the base URL for your Leader. ## Base URLs {#base-urls} The base URL is the root address for making requests to the Cribl API. The standardized base URL format provides a consistent, predictable pattern. Follow the format examples in this section to construct the base URL for your Cribl deployment. The correct base URL depends first on whether the target endpoint is in the [control plane](#control-plane-base-url) or [management plane](#mgmt-plane-base-url). For control plane endpoints, the base URL further depends on whether the target endpoint operates in the [global](#base-url-global), [Group/Fleet or Host](#base-url-group-fleet-host), or [Cribl Search](#base-url-cribl-search) context. In [hybrid deployments](/stream/cloud-enterprise/#hybrid) with a Cribl.Cloud Leader and on-prem workers, API requests use the Cribl.Cloud base URL format. This is true even in the [Group/Fleet or Host](#base-url-group-fleet-host) context because API requests are served from the Cribl.Cloud Leader. To compose the complete URL for a request to a specific endpoint, append the endpoint path that is listed in the [API Reference](/api-reference/) to the base URL. ### Control Plane Base URLs {#control-plane-base-url} The control plane provides operational control over Cribl resources. The control plane is supported for Cribl.Cloud/hybrid and on-prem deployments, and the base URL varies for target endpoints in the [global](#base-url-global), [Group/Fleet or Host](#base-url-group-fleet-host), or [Cribl Search](#base-url-cribl-search) context. #### Global Context {#base-url-global} For API requests to endpoints that apply to the entire Workspace or Organization (Cribl.Cloud/hybrid) or instance (on-prem), use the base URL for global requests. Examples of requests with a global scope include managing feature settings and resources outside of the context of a specific Worker Group or Fleet. In Cribl.Cloud and hybrid deployments, the base URL format for global requests for Cribl Stream, Edge, and Lake endpoints is: ``` https://${workspaceName}-${organizationId}.cribl.cloud/api/v1 ``` In Cribl.Cloud Government and hybrid deployments, the format is the same except the hostname uses `cribl-gov.cloud`: ``` https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1 ``` For single-instance on-prem deployments, use the following base URL format for global requests: ``` https://${hostname}:${port}/api/v1 ``` For example, to send a request to the `GET /system/settings/git-settings` endpoint to retrieve the git settings for the Organization or instance, the complete URL is: **Cribl.Cloud and Hybrid (Global)** ``` https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/system/settings/git-settings ``` **Cribl.Cloud Government and Hybrid (Global)** ``` https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1/system/settings/git-settings ``` **On-Prem (Global)** ``` https://${hostname}:${port}/api/v1/system/settings/git-settings ``` #### Group/Fleet or Host Context {#base-url-group-fleet-host} Some endpoints operate in the context of a specific Worker Group or Edge Fleet or host (Worker or Edge Node). In these cases, the base URL format includes additional URL segments that identify the context and the particular Group/Fleet or Node. Context | URL Segments | Example ------- | ------------ | ------- Endpoints that target a specific Group/Fleet | `/m/${groupName}` | List the commit history for a Worker Group or Edge Fleet with `GET /version` Endpoints that act on a single Worker or Edge Node | `/w/${nodeId}` | Get host metadata with `GET /edge/metadata` ##### Base URL for the Group or Fleet Context {#base-url-group-fleet} For requests that are specific to a Worker Group or Edge Fleet, the base URL includes the `/m` context indicator and the name of the target Worker Group or Fleet: **Cribl.Cloud and Hybrid (Worker Group/Edge Fleet)** ``` https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/${groupName} ``` **Cribl.Cloud Government and Hybrid (Worker Group/Edge Fleet)** ``` https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1/m/${groupName} ``` **On-Prem (Worker Group/Edge Fleet)** ``` https://${hostname}:${port}/api/v1/m/${groupName} ``` > If your license is limited to a single Worker Group, the `groupName` is always `default`. {.box .info} For example, to send a request to the `POST /system/outputs` endpoint to create a Destination for the Worker Group `myDevGroup`, the complete URL is: **Cribl.Cloud and Hybrid (Worker Group/Edge Fleet)** ``` https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/myDevGroup/system/outputs ``` **Cribl.Cloud Government and Hybrid (Worker Group/Edge Fleet)** ``` https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1/m/myDevGroup/system/outputs ``` **On-Prem (Worker Group/Edge Fleet)** ``` https://${hostname}:${port}/api/v1/m/myDevGroup/system/outputs ``` ##### Base URL for the Host Context {#base-url-host} For requests that are specific to a certain host (Worker or Edge Node), the base URL includes the `/w` context indicator and the ID of the target Worker or Edge Node: **Cribl.Cloud and Hybrid (Worker/Edge Nodes)** ``` https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/w/${nodeId} ``` **Cribl.Cloud Government and Hybrid (Worker/Edge Nodes)** ``` https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1/w/${nodeId} ``` **On-Prem (Worker/Edge Nodes)** ``` https://${hostname}:${port}/api/v1/w/${nodeId} ``` To get the `nodeId`, send a request to the `GET /products/{product}/workers` endpoint using the [global context](#base-url-global) for the base URL. The response lists detailed metadata for all Worker and Edge Nodes that the Leader manages. Use the `id` value for the desired Node as the `nodeId` in the request URL. For example, to send a request to the `GET /health` endpoint for the Worker Node `abc123a9-ea69-4066-b295-456defb55784`, the complete URL is: **Cribl.Cloud and Hybrid (Worker/Edge Node)** ``` https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/w/abc123a9-ea69-4066-b295-456defb55784/health ``` **Cribl.Cloud Government and Hybrid (Worker/Edge Node)** ``` https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1/w/abc123a9-ea69-4066-b295-456defb55784/health ``` **On-Prem (Worker/Edge Node)** ``` https://${hostname}:${port}/api/v1/w/abc123a9-ea69-4066-b295-456defb55784/health ``` #### Cribl Search Context {#base-url-cribl-search} For [Cribl Search endpoints](/cribl-as-code/api-reference/control-plane/cribl-search), the base URL includes `/m` and `default_search`: **Cribl.Cloud and Hybrid (Cribl Search)** ``` https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/default_search ``` **Cribl.Cloud Government and Hybrid (Cribl Search)** ``` https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1/m/default_search ``` For example, for a request to the `GET /search/jobs/{id}` endpoint, the complete URL is: **Cribl.Cloud and Hybrid (Cribl Search)** ``` https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/default_search/search/jobs/{id} ``` **Cribl.Cloud Government and Hybrid (Cribl Search)** ``` https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1/m/default_search/search/jobs/{id} ``` ### Management Plane Base URL {#mgmt-plane-base-url} The management plane includes endpoints for administrative tasks like configuring and managing Workspaces. The management plane is supported for commercial Cribl.Cloud only. > Cribl.Cloud Government does not support the management plane API. > {.box .cloud} For [management plane endpoints](/cribl-as-code/api-reference/management-plane/), the base URL is: ``` https://gateway.cribl.cloud ``` For example, for a request to the `GET /v1/organizations/{organizationId}/workspaces` endpoint, the complete URL is: ``` https://gateway.cribl.cloud/v1/organizations/${organizationId}/workspaces ``` ## Path Parameters Many Cribl API endpoints require to you provide path parameters. Most path parameters are used to specify individual resources. For example, in the endpoint `GET /pack/{id}`, the `{id}` identifies the specific Cribl Pack to retrieve. For some endpoints, path parameters limit the scope of the request in some way. For example, in the endpoint `GET /products/{product}/groups`, the `{product}` path parameter indicates the Cribl product whose Worker Groups or Edge Fleets should be listed in the response. In another example, `GET /p/{pack}/pipelines`, the `{pack}` path parameter limits the response to Pipelines within the specified Pack. The [API Reference](/api-reference/) identifies and describes the path parameters for each endpoint. ## Query Parameters Some Cribl API endpoints support optional query parameters for filtering or modifying the response. For example, endpoints that return a list of objects can have lengthy responses, so they might support `limit` and `offset` query parameters to use for paginating the response. Other endpoints might support query parameters that allow you to specify additional properties to include in the response or a JavaScript expression to apply as a filter. The [API Reference](/api-reference/) identifies and describes the supported query parameters for each endpoint. ## Request Size Limit The size limit for requests to the Cribl API is 5 MB. ## Rate Limits {#rate-limits} Cribl applies rate limits for API requests so that excessive traffic does not interfere with normal operations. The rate limits vary for different Cribl API endpoints. You can directly change rate limits for only the [login and SSO/SLO callback endpoints](#login-sso-slo-rate-limits). When a request exceeds an endpoint's rate limit, the API returns HTTP status code `429 Too Many Requests` and a `Retry-After` response header. The `Retry-After` header value is the number of seconds to wait before retrying the request. The response body includes the `limiter` attribute, which identifies the rate limit that the request exceeded. > In Cribl.Cloud, if a rate limit repeatedly prevents requests, contact [Cribl Support](/support/) to request an adjustment at the Organization or Workspace level. Provide the `limiter` value from the `429 Too Many Requests` response body with your adjustment request. > {.box .cloud} Each Leader or Node tracks its own rate limits. Requests from all clients to the same Leader or Node count toward the same rate limit. ### Rate Limits for Login and SSO/SLO Endpoints {#login-sso-slo-rate-limits} You can change the default rate limits for the following on-prem API endpoints: |
Endpoints
| Purpose | Default Rate Limit | | --- | --- | --- | | `POST /auth/login` | Log in and get a Bearer token to authenticate subsequent API requests. | Two requests per second | | `GET /auth/sso/callback`
`POST /auth/sso/callback`
`GET /auth/slo/callback`
`POST /auth/slo/callback` | Receive and process SAML sign-in and sign-out responses from the identity provider. All four endpoints share the rate limit. | Two requests per second | Updated limits take effect without restarting the affected Leader or Node. To change rate limits for the login and SSO/SLO endpoints with the API, use `PATCH /system/api-limits`. The following example demonstrates how to increase the rate limits for the login and SSO/SLO endpoints from 2 requests per second to 10 requests per second: - For the login endpoint, use the `rateLimits.login.rate` and `rateLimits.login.interval` body parameters. - For the SSO/SLO endpoints, use the `rateLimits.sso.rate` and `rateLimits.sso.interval` body parameters. **Change Login and SSO/SLO Endpoint Rate Limits (On-Prem)** ```shell curl --request PATCH \ --url "https://${hostname}:${port}/api/v1/system/api-limits" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "rateLimits": { "login": { "rate": 10, "interval": "second" }, "sso": { "rate": 10, "interval": "second" } } }' ``` You can also use the Cribl UI or the `api-limits.yml` configuration file to change the rate limits for these endpoints: - In the Cribl UI, set the **Login rate limit** and **SSO/SLO callback rate limit** for the [Leader](/iam/authentication#auth-controls), [Worker Group](/stream/group-settings#api-limits), or [Edge Fleet](/edge/fleet-settings#api-limits). - In the [`api-limits.yml`](/stream/api-limitsyml) configuration file, set `rateLimits.login` and `rateLimits.sso`. ## Media Types For endpoints that require a request body (typically `POST`, `PUT`, and `PATCH`), the server expects a valid `Content-Type` [request header](https://developer.mozilla.org/en-US/docs/Glossary/Request_header) that specifies the media type of the request body. In this example request, the `Content-Type` value is `application/json`: ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/default_search/search/jobs" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "query": "cribl dataset=\"goatherd_sample_dataset\" | limit 1000", "earliest": "-1h", "latest": "now", "sampleRate": 1 }' ``` If the request omits the `Content-Type` header or the value does not match the supported media type for the endpoint, the server might return an error. For most `POST`, `PUT`, and `PATCH` endpoints in the Cribl API, the media type for the request body is `application/json`. Some endpoints support other media types, such as `application/x-ndjson` or `application/x-www-form-urlencoded`. The [API Reference](/api-reference/) specifies the supported media type for each endpoint in the **Request body** drop-down list. ![Location of the request body media type for an endpoint in the API Reference.](request-media-type-api-reference.png) {border="true" caption="Endpoint's request body media type in API Reference"} The [API Reference](/api-reference/) also specifies the media type for each endpoint's responses, which is helpful for ensuring proper data processing. ![Location of the response media type for an endpoint in the API Reference.](response-media-type-api-reference.png) {border="true" caption="Endpoint's response media type in API Reference"} ## HTTP Status Codes The Cribl API can return the following HTTP status codes in response headers: | HTTP Status Code | Meaning | | -------------------------- | --------------------------- | | 200 OK | The request was successful. | | 204 No Content | The request was successful, but there is no content to send in the response. Often used for `DELETE` requests. | | 400 Bad Request | The server could not understand the request due to malformed syntax or missing parameters. | | 401 Unauthorized | Authentication failed because credentials are missing or invalid. | | 403 Forbidden | The server understood the request but did not authorize it because permissions are insufficient to access the requested resource. | | 404 Not Found | The requested resource was not found. The endpoint may not exist or the resource may be unavailable. | | 405 Method Not Allowed | The request method is not supported for the resource (for example, a `POST` request for a resource that only supports `GET`). | | 415 Unsupported Media Type | The server did not accept the request because the payload is in an unsupported data format. Often indicates that the `Content-Type` header is incorrect. | | 420 Shutting Down | The server is in the process of shutting down or is in standby. | | 429 Too Many Requests | The number of requests exceeds a [rate limit](#rate-limits). | | 500 Internal Server Error | The server encountered an unexpected condition that prevented it from fulfilling the request. | | 502 Bad Gateway | While acting as a gateway or proxy, the server received an invalid response from the upstream server. | | 503 Service Unavailable | The server could not handle the request due to temporary overload or maintenance. | See the [MDN Web Docs](https://developer.mozilla.org/en-US/docs/Web/HTTP/Status) for more information about HTTP status codes. ############################################################ # SOURCE: https://docs.cribl.io/cribl-as-code/api-auth.md ############################################################ # Authenticate with the Cribl API All Cribl API requests require you to authenticate with a Bearer token, except `GET /health` in the [global context](api#base-url-global) and `POST /auth/login`. In Cribl, Bearer tokens are [JSON Web Tokens (JWTs)](https://datatracker.ietf.org/doc/html/rfc7519). You must include a valid Bearer token in the `Authorization` header of your API requests. The Bearer token verifies your identity and ensures secure access to the requested resources. The process for retrieving the Bearer token depends on whether you authenticate in [commercial Cribl.Cloud and hybrid](#api-auth-cloud) deployments, [Cribl.Cloud Government and hybrid](#api-auth-gov) deployments, or [on-prem](#api-auth-on-prem) deployments. - In Cribl.Cloud and hybrid deployments, Bearer tokens are valid for `24` hours. - In on-prem deployments, Bearer tokens expire according to the value you provide for the **Auth token TTL** setting at **Settings** > **Global** > **General Settings** > **API Server Settings** > **Advanced**. The default setting is `3600` seconds (`1` hour). {scale="90%" border="true"} You are responsible for ensuring that your applications obtain a new Bearer token within the expiration window for each token. > For on-prem deployments, if you're using SSO/OpenID Connect Authentication, you must toggle on **Allow login as Local User** in Cribl (see [Set Up Fallback Access](/iam/sso-on-prem/#fallback-access-on-prem)). You'll need to be a Local user when you authenticate. > > To use `https` for on-prem requests, you must [Configure TLS](/stream/securing-configure-tls/). If you do not configure TLS, use `http` instead. Use `http` only for testing in development environments. In production, configure TLS and use `https` to secure your communications. > {.box .warning} ## Authenticate in Cribl.Cloud and Hybrid Deployments {#api-auth-cloud} To authenticate for API requests to [control plane](/cribl-as-code/control-plane/) (Cribl.Cloud or hybrid) or [management plane](/cribl-as-code/api-reference/management-plane/) (Cribl.Cloud) endpoints, first create an API Credential. The API Credential provides a **Client ID** and **Client Secret**. Provide these in a request to `https://login.cribl.cloud/oauth/token` to obtain a 24-hour Bearer token to authenticate subsequent API requests. > API Credentials that refresh Bearer tokens at a high frequency are subject to [rate limits](api#rate-limits). > {.box .info} The authentication process is the same for [control plane](/cribl-as-code/control-plane/) and [management plane](/cribl-as-code/api-reference/management-plane/) access. The difference is the [base URL](api#base-urls) and endpoints used for subsequent API requests. > For Cribl.Cloud Government, follow the separate [authentication instructions](#api-auth-gov) instead. > {.box .cloud} You can create API Credentials with the `POST /api-credentials` endpoint in the Cribl [management plane API](/cribl-as-code/api-reference/management-plane/). However, you must first create the initial API Credential manually in the Cribl UI. This is necessary because Cribl API requests require a Bearer token, which in turn requires an API Credential. After you create the first API Credential, you can retrieve a Bearer token to use in [API requests to create new API Credentials](api-create-api-credentials). To create an API Credential in the Cribl UI: 1. Log in to Cribl.Cloud as an Owner or an Admin. 1. On the top bar, select **Products**, and then select **Cribl**. 1. In the sidebar, select **Organization**, and then select **API Credentials**. 1. Select **Add Credential**. 1. Enter a **Name** and an optional **Description**. 1. In the **Organization Permissions** drop-down menu, select a [Permission](/iam/permissions#organization) to apply for the API Credential. **Organization Permissions** are available on [certain plan/license tiers](https://cribl.io/pricing/). Without a proper license, all API Credentials are granted the **Admin** Permission. - The **Admin** or **Owner** Permission automatically grants admin access on all Workspaces. - If you choose the **User** Permission, under **Workspace Access**, define the desired [Permissions](/iam/permissions#workspace) for specific [Workspaces](/stream/workspaces) and Cribl products. - To grant read-only access on [individual Cribl Search resources](/search/sharing#share-datasets-dashboards) (for example, for a service account that connects to Cribl Search via API), select the **User** Permission on the Organization, the **Member** Permission on the Workspace, and either the **User** or **Editor** Permission on Cribl Search. The **Admin** Permission automatically grants full access to all Cribl Search resources. - The **Billing Reader** Permission grants read-only access to billing information for the Organization. It does not grant access to Workspaces or products. 1. (Optional) Under **IP Allowlist**, you can restrict API access for the Credential to specific IPv4 Classless Inter-Domain Routing (CIDR) ranges. Select **Add CIDR** and enter the desired range. You can add a maximum of 10 CIDR ranges. 1. Select **Save**. The **API Credentials** page displays the new API Credential within a few seconds. The API Credential includes a **Client ID** and a **Client Secret** that Organization Owners and Admins can use to generate Bearer tokens. Organization Owners and Admins can view, edit, and disable existing API Credentials. Only Owners can delete API Credentials. > The **Client ID** and **Client Secret** are sensitive information and should be kept private. > {.box .info} Once you have the **Client ID** and **Client Secret**, send them in a request to `https://login.cribl.cloud/oauth/token` to retrieve the 24-hour Bearer token to use to authenticate subsequent API requests. The request body includes these fields: - `grant_type`: The OAuth grant type. For API Credentials, the value is always `client_credentials`. - `client_id` and `client_secret`: The **Client ID** and **Client Secret** from the API Credential. The **Client ID** and **Client Secret** are sensitive information and should be kept private, so the example request shows how to provide them as variables. - `audience`: The API identifier for Cribl.Cloud in Auth0. The value is always `https://api.cribl.cloud`. This is not the URL to use for subsequent API requests, which require the appropriate [base URL](api#base-urls) as shown in the [API request example](#api-request-example-cloud). **Authentication Request Example (Cribl.Cloud and Hybrid)** ```shell curl --request POST \ --url "https://login.cribl.cloud/oauth/token" \ --header "Content-Type: application/json" \ --data "{ \"grant_type\": \"client_credentials\", \"client_id\": \"${clientId}\", \"client_secret\": \"${clientSecret}\", \"audience\": \"https://api.cribl.cloud\" }" ``` As shown in the following example response, the JSON object in the response includes several attributes: - `access_token`: The Bearer token to use in the `Authorization` header for authentication in subsequent API requests. - `scope`: The [Permissions](/iam/permissions) that the Bearer token grants. - `expires_in`: The number of seconds until the Bearer token expires. In Cribl.Cloud/hybrid, Bearer tokens expire `24` hours (`86400` seconds) after they are created. You are responsible for ensuring that your applications obtain a new Bearer token within the expiration window for each token. - `token_type`: The type of the token. In Cribl.Cloud/hybrid, the value is always `Bearer`. **Authentication Response Example (Cribl.Cloud/Hybrid)** ```json { "access_token": "abcdefg1234567890...exampleBearerToken", "scope": "user:read:workergroups user:update:workergroups user:read:connections user:update:connections user:update:workspaces user:read:workspaces", "expires_in": 86400, "token_type": "Bearer" } ``` To use the Bearer token in subsequent API requests, include it in the `Authorization` header as shown in this control plane example: **API Request Example (Cribl.Cloud and Hybrid)** ```shell curl --request GET \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/${groupName}/system/inputs" \ --header "Authorization: Bearer abcdefg1234567890...exampleBearerToken" \ --header "Content-Type: application/json" ``` ## Authenticate in Cribl.Cloud Government and Hybrid Deployments {#api-auth-gov} To authenticate for API requests to [control plane](/cribl-as-code/control-plane/) endpoints in Cribl.Cloud Government and hybrid deployments, first create an API Credential. The API Credential provides a **Client ID** and **Client Secret**. Provide these in a request to `https://criblgov-prod.okta.com/oauth2/ausfuanngyqh8CJ6c4h7/v1/token` to obtain a 24-hour Bearer token to authenticate subsequent API requests. > API Credentials that refresh Bearer tokens at a high frequency are subject to [rate limits](api#rate-limits). > {.box .info} > Cribl.Cloud Government does not support [management plane](/cribl-as-code/api-reference/management-plane/) API endpoints or the **IP Allowlist** option for API Credentials. > > API authentication request details differ between Cribl.Cloud Government and commercial Cribl.Cloud, such as the request URL, request header, and audience value. Follow the instructions and examples in this section. > {.box .cloud} To create an API Credential in the Cribl.Cloud Government UI: 1. Log in to Cribl.Cloud Government as an Owner or an Admin. 1. On the top bar, select **Products**, and then select **Cribl**. 1. In the sidebar, select **Organization**, and then select **API Credentials**. 1. Select **Add Credential**. 1. Enter a **Name** and an optional **Description**. 1. In the **Organization Permissions** drop-down menu, select a [Permission](/iam/permissions#organization) to apply for the API Credential. **Organization Permissions** are available on [certain plan/license tiers](https://cribl.io/pricing/). Without a proper license, all API Credentials are granted the **Admin** Permission. - The **Admin** or **Owner** Permission automatically grants admin access on all Workspaces. - If you choose the **User** Permission, under **Workspace Access**, define the desired [Permissions](/iam/permissions#workspace) for specific [Workspaces](/stream/workspaces) and Cribl products. - To grant read-only access on [individual Cribl Search resources](/search/sharing#share-datasets-dashboards) (for example, for a service account that connects to Cribl Search via API), select the **User** Permission on the Organization, the **Member** Permission on the Workspace, and either the **User** or **Editor** Permission on Cribl Search. The **Admin** Permission automatically grants full access to all Cribl Search resources. - The **Billing Reader** Permission grants read-only access to billing information for the Organization. It does not grant access to Workspaces or products. 1. Select **Save**. The **API Credentials** page displays the new API Credential within a few seconds. The API Credential includes a **Client ID** and a **Client Secret** that Organization Owners and Admins can use to generate Bearer tokens. Organization Owners and Admins can view, edit, and disable existing API Credentials. Only Owners can delete API Credentials. > The **Client ID** and **Client Secret** are sensitive information and should be kept private. Client IDs and Client Secrets are not interchangeable between commercial Cribl.Cloud and Cribl.Cloud Government. > {.box .info} Once you have the **Client ID** and **Client Secret**, send them as form fields in a request to `https://criblgov-prod.okta.com/oauth2/ausfuanngyqh8CJ6c4h7/v1/token` to retrieve the 24-hour Bearer token to use to authenticate subsequent API requests. The request includes these form fields: - `grant_type`: The OAuth grant type. For API Credentials, the value is always `client_credentials`. - `client_id` and `client_secret`: The **Client ID** and **Client Secret** from the API Credential. The **Client ID** and **Client Secret** are sensitive information and should be kept private, so the example request shows how to provide them as variables. - `audience`: The audience configured for Cribl.Cloud Government in Okta. The value is always `https://api.cribl-gov.cloud`. This is not the URL to use for subsequent API requests, which require the appropriate [base URL](api#base-urls) as shown in the [API request example](#api-request-example-gov). **Authentication Request Example (Cribl.Cloud Government and Hybrid)** ```shell curl --request POST \ --url "https://criblgov-prod.okta.com/oauth2/ausfuanngyqh8CJ6c4h7/v1/token" \ --header "Content-Type: application/x-www-form-urlencoded" \ --data-urlencode "grant_type=client_credentials" \ --data-urlencode "client_id=${clientId}" \ --data-urlencode "client_secret=${clientSecret}" \ --data-urlencode "audience=https://api.cribl-gov.cloud" ``` As shown in the following example response, the JSON object in the response includes several attributes: - `token_type`: The type of the token. In Cribl.Cloud Government and hybrid deployments, the value is always `Bearer`. - `expires_in`: The number of seconds until the Bearer token expires. In Cribl.Cloud Government and hybrid deployments, Bearer tokens expire `24` hours (`86400` seconds) after they are created. You are responsible for ensuring that your applications obtain a new Bearer token within the expiration window for each token. - `access_token`: The Bearer token to use in the `Authorization` header for authentication in subsequent API requests. - `scope`: In Cribl.Cloud Government and hybrid deployments, the value is always `zeus_api_access`. The authentication server grants this default scope for every API Credential token. The [Permissions](/iam/permissions) that you assigned to the API Credential still determine which API operations the Bearer token can perform. **Authentication Response Example (Cribl.Cloud Government and Hybrid)** ```json { "token_type": "Bearer", "expires_in": 86400, "access_token": "abcdefg1234567890...exampleBearerToken", "scope": "zeus_api_access" } ``` To use the Bearer token in subsequent API requests, include it in the `Authorization` header as shown in this control plane example: **API Request Example (Cribl.Cloud Government and Hybrid)** ```shell curl --request GET \ --url "https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1/m/${groupName}/system/inputs" \ --header "Authorization: Bearer abcdefg1234567890...exampleBearerToken" \ --header "Content-Type: application/json" ``` ## Authenticate in On-Prem Deployments {#api-auth-on-prem} To authenticate using the API in on-prem deployments, send a request to the `/auth/login` endpoint. The response includes the Bearer token required for subsequent API requests. The following example request demonstrates an `/auth/login` request. Replace the variables in the example request with your hostname, port, and login credentials (username and password). Your username and password are sensitive information and should be kept private, so the example request shows how to provide them as variables. **Authentication Request Example (On-Prem Deployment)** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/auth/login" \ --header "Content-Type: application/json" \ --data "{ \"username\": \"${username}\", \"password\": \"${password}\" }" ``` The response is a JSON object like the following example. The value of the `token` attribute in the response is the Bearer token: **Authentication Response Example (On-Prem Deployment)** ```json { "token": "abcdefg1234567890...exampleBearerToken", "forcePasswordChange": false } ``` To use the Bearer token in subsequent API requests, include it in the `Authorization` header, like this: **API Request Example (On-Prem Deployment)** ```shell curl --request GET \ --url "https://${hostname}:${port}/api/v1/m/${groupName}/system/inputs" \ --header "Authorization: Bearer abcdefg1234567890...exampleBearerToken" \ --header "Content-Type: application/json" ``` ## Authenticate and Create HEC Tokens with Python {#hec-tokens} Cribl Solutions Engineering developed an example script that demonstrates how to use Python to authenticate to the Cribl API, make a simple POST request, and add a new HEC token. The script and instructions for usage are available in the [`py_hec_token_mgr` GitHub repo](https://github.com/camrunr/py_hec_token_mgr). To use the script, you'll need: - Python 3. - The Python 3 Requests module (use brew or pip3 to install). - A working, distributed Cribl Stream or Edge installation, with a configured [Splunk HEC Source](/stream/sources-splunk-hec). - An admin username and password. ############################################################ # SOURCE: https://docs.cribl.io/cribl-as-code/api-code-examples.md ############################################################ # Cribl API Code Examples These code examples demonstrate how to use the Cribl API directly to complete a task or set of tasks. Each example describes the steps required to complete a specific task, identifies the endpoints to use, and provides example requests and responses. The API code examples complement our [API Reference](/api-reference/) and explain common usage scenarios for the Cribl API. If you want to automate an action in Cribl for which you can't find documentation, ask in the [Cribl Community `#docs` channel](https://cribl-community.slack.com/archives/C01BM8PU30V). > ##### About Code Examples > > Code examples use Bearer token authentication. Read the [API authentication documentation](api-auth) to learn how to configure authentication. The API Credential (Cribl.Cloud and hybrid) or login credentials (on-prem) that you use to obtain the Bearer token must have the necessary [Permissions](/iam/permissions) for the operations in code examples. > > Replace the variables in code examples with the corresponding information for your Cribl deployment. > > In Cribl.Cloud Government, use `cribl-gov.cloud` in request URLs instead of `cribl.cloud`. For example, `https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1`. > > For on-prem deployments, to use `https` in request URLs, you must [Configure TLS](/stream/securing-configure-tls/). > > Code examples do not include all available body parameters. For a complete list of body parameters for specific endpoints, refer to the documentation in the [API Reference](/api-reference). > {.box .info} The following Cribl API code examples are available: - [Configure Worker Groups](api-configure-worker-groups) - [Configure Resources](api-configure-resources) - [Update Configurations](update-configurations) - [Copy, Export, and Install Packs](copy-export-install-packs) - [Create and Update Lookups](create-update-lookups) - [Commit and Deploy Changes](commit-deploy) - [View Large Diffs](view-large-diffs) - [Query the Health Endpoint](query-health-endpoint) - [Create New API Credentials](api-create-api-credentials) (management plane) - [Add a Cribl Search Pack and Create a Lake Dataset](api-search-pack-lake-dataset) - [Search and Retrieve Results](search-results) - [Get Alerts for Search Results](get-alerts-search-results) - [Get Cumulative Consumption by Contract](api-billing-contracts-utilization) - [Get Monthly or Daily Credit Consumption](api-billing-monthly-daily-consumption) - [Get Credit Grants and Statistics](api-billing-grants-statistics) ############################################################ # SOURCE: https://docs.cribl.io/cribl-as-code/api-configure-worker-groups.md ############################################################ # Configure Worker Groups with the Cribl API These code examples demonstrate how to use the [Cribl API](api) to configure, scale, replicate, and deploy [Worker Groups](/stream/deploy-distributed/#concepts) in Cribl Stream. > ##### About Code Examples > > Code examples use Bearer token authentication. Read the [API authentication documentation](api-auth) to learn how to configure authentication. The API Credential (Cribl.Cloud and hybrid) or login credentials (on-prem) that you use to obtain the Bearer token must have the necessary [Permissions](/iam/permissions) for the operations in code examples. > > Replace the variables in code examples with the corresponding information for your Cribl deployment. > > In Cribl.Cloud Government, use `cribl-gov.cloud` in request URLs instead of `cribl.cloud`. For example, `https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1/products/stream/groups`. > > For on-prem deployments, to use `https` in request URLs, you must [Configure TLS](/stream/securing-configure-tls/). > > Code examples do not include all available body parameters. For a complete list of body parameters for specific endpoints, refer to the documentation in the [API Reference](/api-reference). > {.box .info} The examples for [creating](#create-worker-group-api) and [scaling](#scale-worker-group-api) a Worker Group on Cribl.Cloud include the `estimatedIngestRate` property, which allows you to configure Worker Groups for optimal performance. For each supported `estimatedIngestRate` value, the following table maps the corresponding throughput and number of Worker Processes: | `estimatedIngestRate` | Throughput | Worker Processes | | --------------------- | ---------- | ---------------- | | 1024 | 12 MB/s | 6 | | 2048 | 24 MB/s | 9 | | 3072 | 36 MB/s | 14 | | 4096 | 48 MB/s | 21 | | 5120 | 60 MB/s | 30 | | 7168 | 84 MB/s | 45 | | 10240 | 120 MB/s | 62 | | 13312 | 156 MB/s | 93 | | 15360 | 180 MB/s | 186 | ## 1. Create a Worker Group {#create-worker-group-api} This example creates a new Worker Group in Cribl Stream. In the Cribl.Cloud example, the [`estimatedIngestRate`](#est-ingest-rates-api) is set to `2048`, which is equivalent to a maximum of 24 MB/s with nine Worker Processes. In the on-prem deployment example, the new Worker Group is created with eight Workers. **Cribl.Cloud** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/products/stream/groups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "my-worker-group", "name": "my-worker-group", "description": "Cribl.Cloud Worker Group", "cloud": { "provider": "aws", "region": "us-west-2" }, "workerRemoteAccess": true, "isFleet": false, "isSearch": false, "onPrem": false, "estimatedIngestRate": 2048, "provisioned": false }' ``` **On-Prem** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/products/stream/groups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "my-worker-group", "name": "my-worker-group", "description": "My Worker Group description", "workerRemoteAccess": true, "isFleet": false, "isSearch": false, "onPrem": true, "workerCount": 8 }' ``` ## 2. Scale the Worker Group {#scale-worker-group-api} The Cribl.Cloud example scales the Worker Group to an [`estimatedIngestRate`](#est-ingest-rates-api) of 4096, which is equivalent to a maximum of 48 MB/s with 21 Worker Processes. The example also sets provisioned to true to activate Cribl.Cloud resources. The on-prem example assumes the Syslog Source load balancer (LB) is enabled on a Cribl Stream system with 6 physical cores hyperthreaded (12 vCPUs). Because the Syslog Source LB reserves an additional core, the example scales the process count from the default to `-3`: two cores for system/API overhead plus one for the LB process, so the system spawns nine Worker Processes. For more information, see [Optimize a Distributed Deployment or Hybrid Group](/stream/scaling#optimize-a-distributed-deployment-or-hybrid-group) and [Choose a Process Count](/stream/scaling#choose-a-process-count). The on-prem example also updates the Worker Group system settings, commits and deploys the changes, and restarts the Worker Group to apply the changes. > The request bodies for the `PATCH /products/{product}/groups/{id}` (Cribl.Cloud) and `PATCH /system/settings/conf` (on-prem) endpoints must include a **complete** representation of the Worker Group or settings, respectively, that you want to update. These endpoints do not support partial updates. Cribl removes any omitted fields when updating the Worker Group or settings. > {.box .warning} **Cribl.Cloud** ```shell curl --request PATCH \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/products/stream/groups/my-worker-group" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "my-worker-group", "name": "my-worker-group", "description": "Cribl.Cloud Worker Group", "cloud": { "provider": "aws", "region": "us-west-2" }, "workerRemoteAccess": true, "isFleet": false, "isSearch": false, "onPrem": false, "estimatedIngestRate": 4096, "provisioned": true }' ``` **On-Prem** ```shell curl --request PATCH \ --url "https://${hostname}:${port}/api/v1/products/stream/groups/my-worker-group" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "api": { "host": "0.0.0.0", "port": 1234, "ssl": { "disabled": false, "certificateName": "myCertificate", "certPath": "$CRIBL_HOME/local/cribl/auth/certs/myCertificate.crt", "privKeyPath": "$CRIBL_HOME/local/cribl/auth/certs/myCertificate.key" } }, "system": { "upgrade": "api", "intercom": true }, "workers": { "count": -3, "memory": 2048, "minimum": 2 }, "proxy": { "useEnvVars": true }, "upgradeSettings": { "disableAutomaticUpgrade": true, "enableLegacyEdgeUpgrade": false }, "shutdown": { "drainTimeout": 10 } }' ``` ## 3. Replicate the Worker Group {#replicate-worker-group-api} This example creates a replica Worker Group in Cribl Stream by cloning an existing Worker Group configuration. The new Worker Group uses the `sourceGroupId` body parameter to specify the Worker Group to clone. The replica Worker Group inherits the configuration from the source Worker Group, including settings and resources like Sources, Destinations, and Pipelines. To run this example, you must have at least one existing Worker Group named `my-worker-group` in Cribl Stream to use as the source Worker Group. **Cribl.Cloud** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/products/stream/groups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "my-replica-worker-group", "name": "my-replica-worker-group", "description": "Worker Group cloned from my-worker-group with identical configuration", "cloud": { "provider": "aws", "region": "us-west-2" }, "workerRemoteAccess": true, "isFleet": false, "isSearch": false, "onPrem": false, "sourceGroupId": "my-worker-group" }' ``` **On-Prem** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/products/stream/groups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "my-replica-worker-group", "name": "my-replica-worker-group", "description": "Worker Group cloned from my-worker-group with identical configuration", "workerRemoteAccess": true, "isFleet": false, "isSearch": false, "onPrem": true, "sourceGroupId": "my-worker-group" }' ``` ## 4. Confirm the Worker Group Configuration {#confirm-worker-group-api} Use this example to retrieve a list of all Worker Groups in Cribl Stream so that you can review and confirm their configurations. **Cribl.Cloud** ```shell curl --request GET \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/products/stream/groups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" ``` **On-Prem** ```shell curl --request GET \ --url "https://${hostname}:${port}/api/v1/products/stream/groups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" ``` ## 5. Commit and Deploy the Worker Group {#commit-deploy-worker-group-api} This example demonstrates how to commit and deploy the Worker Group configurations, then commit to the Leader to keep it in sync with the Worker Groups. You can commit and deploy immediately after a single [create](#create-worker-group-api) or [update](#scale-worker-group-api) request or after multiple requests. On-prem deployments also require restarting the Worker Groups if you want their new configurations to take effect. First, commit pending changes to the Worker Group. This request commits only the configuration changes for the Worker Group by specifying the file `local/cribl/groups.yml`. Repeat this request for each Worker Group whose changes you want to commit. **Cribl.Cloud** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/version/commit?groupId=my-worker-group" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "files": [ "local/cribl/groups.yml" ], "message": "Commit Worker Group configuration" }' ``` **On-Prem** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/version/commit?groupId=my-worker-group" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "files": [ "local/cribl/groups.yml" ], "message": "Commit Worker Group configuration" }' ``` Second, deploy the committed changes to the Worker Group. This request includes the `version` body parameter, which uses the value of `commit` from the response body for the commit request. Repeat this request for each Worker Group whose committed changes you want to deploy. **Cribl.Cloud** ```shell curl --request PATCH \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/products/stream/groups/my-worker-group/deploy" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "version": 1234abcd5678efgh9012ijkl3456mnop7EXAMPLE }' ``` **On-Prem** ```shell curl --request PATCH \ --url "https://${hostname}:${port}/api/v1/products/stream/groups/my-worker-group/deploy" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "version": 1234abcd5678efgh9012ijkl3456mnop7EXAMPLE }' ``` Commit the changes to the Leader to keep the Leader in sync with the Worker Group. **Cribl.Cloud** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/version/commit" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "message": "Sync my-worker-group with Leader" }' ``` **On-Prem** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/version/commit" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "message": "Sync my-worker-group with Leader" }' ``` Finally, for on-prem deployments only, restart the Worker Group. Repeat this request for each Worker Group whose configuration you want to take effect. **On-Prem** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/m/my-worker-group/system/settings/restart" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" ``` ############################################################ # SOURCE: https://docs.cribl.io/cribl-as-code/api-configure-resources.md ############################################################ # Configure Resources with the Cribl API These code examples demonstrate how to use the [Cribl API](api) to create the following resources in Cribl Stream: - A [Syslog Source](/stream/sources-syslog/) to receive data on port 9021. - An [S3 Destination](/stream/destinations-s3/) to store processed data. - A [Pipeline](/stream/pipelines/) that filters events and keeps only data in the `eventSource` and `eventID` fields. - A [Route](/stream/routes/) that connects the Source, Pipeline, and Destination. The examples also include [deploying](#commit-deploy-resource-configs) the resource configurations to a Worker Group to make them active. The examples use the Worker Group created in [Configure Worker Groups](api-configure-worker-groups) to manage the resource configuration. > ##### About Code Examples > > Code examples use Bearer token authentication. Read the [API authentication documentation](api-auth) to learn how to configure authentication. The API Credential (Cribl.Cloud and hybrid) or login credentials (on-prem) that you use to obtain the Bearer token must have the necessary [Permissions](/iam/permissions) for the operations in code examples. > > Replace the variables in code examples with the corresponding information for your Cribl deployment. > > In Cribl.Cloud Government, use `cribl-gov.cloud` in request URLs instead of `cribl.cloud`. For example, `https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1/m/my-worker-group/system/inputs`. > > For on-prem deployments, to use `https` in request URLs, you must [Configure TLS](/stream/securing-configure-tls/). > > Code examples do not include all available body parameters. For a complete list of body parameters for specific endpoints, refer to the documentation in the [API Reference](/api-reference). > {.box .info} ## Create a Source {#create-source-api} This example creates a [Syslog Source](/stream/sources-syslog/) to receive data on port 9021. **Cribl.Cloud and Hybrid** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/my-worker-group/system/inputs" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "in_syslog_9021", "type": "syslog", "disabled": true, "tcpPort": 9021, "host": "192.168.1.100" }' ``` **On-Prem** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/m/my-worker-group/system/inputs" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "in_syslog_9021", "type": "syslog", "disabled": true, "tcpPort": 9021, "host": "192.168.1.100" }' ``` ## Create a Destination {#create-destination-api} This example creates an [S3 Destination](/stream/destinations-s3/) to store processed data. Replace placeholder values like `your-aws-api-key` before you run the example. **Cribl.Cloud and Hybrid** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/my-worker-group/system/outputs" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "out_s3", "type": "s3", "awsAuthenticationMethod": "manual", "awsApiKey": "your-aws-api-key", "awsSecretKey": "your-aws-secret-key", "region": "us-east-2", "bucket": "your-aws-bucket-name", "compress": "gzip", "compressionLevel": "best_speed", "stagePath": "$CRIBL_HOME/state/outputs/staging", "emptyDirCleanupSec": 300 }' ``` **On-Prem** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/m/my-worker-group/system/outputs" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "out_s3", "type": "s3", "awsAuthenticationMethod": "manual", "awsApiKey": "your-aws-api-key", "awsSecretKey": "your-aws-secret-key", "region": "us-east-2", "bucket": "your-aws-bucket-name", "compress": "gzip", "compressionLevel": "best_speed", "stagePath": "$CRIBL_HOME/state/outputs/staging", "emptyDirCleanupSec": 300 }' ``` ## Create a Pipeline {#create-pipeline-api} This example creates a [Pipeline](/stream/pipelines/) that filters events and keeps only data in the `eventSource` and `eventID` fields. **Cribl.Cloud and Hybrid** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/my-worker-group/pipelines" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "my_pipeline", "conf": { "asyncFuncTimeout": 1000, "functions": [ { "filter": "true", "conf": { "remove": [ "*" ], "keep": [ "eventSource", "eventID" ] }, "id": "eval", "final": true } ] } }' ``` **On-Prem** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/m/my-worker-group/pipelines" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "my_pipeline", "conf": { "asyncFuncTimeout": 1000, "functions": [ { "filter": "true", "conf": { "remove": [ "*" ], "keep": [ "eventSource", "eventID" ] }, "id": "eval", "final": true } ] } }' ``` ## Create a Route {#create-route-api} This example creates a [Route](/stream/routes/) that connects the Syslog Source, Pipeline, and S3 Destination and adds it to the end of the `default` Routing table. The Routing table already includes a `default` Route, so this request changes the `default` Route's setting for `final` to `false` so that it won't block the new Route. > The `PATCH /routes/default` endpoint requires a **complete** representation of the Routing table and its existing Routes in the request body. This endpoint does not support partial updates. Cribl removes any omitted fields when updating the Routing table. Use `GET /routes/default` to retrieve the existing Routing table to use in the body of the PATCH request. > {.box .warning} **Cribl.Cloud and Hybrid** ```shell curl --request PATCH \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/my-worker-group/routes/default" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "default", "routes": [ { "id": "0abcd9", "name": "default", "final": false, "disabled": false, "pipeline": "main", "enableOutputExpression": false, "filter": "true", "output": "default" }, { "name": "my_route", "final": true, "disabled": false, "pipeline": "my_pipeline", "enableOutputExpression": false, "filter": "__inputId == 'syslog:in_syslog_9021:tcp'", "output": "out_s3", "description": "This is my new Route" } ] }' ``` **On-Prem** ```shell curl --request PATCH \ --url "https://${hostname}:${port}/api/v1/m/my-worker-group/routes/default" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "default", "routes": [ { "id": "0abcd9", "name": "default", "final": false, "disabled": false, "pipeline": "main", "enableOutputExpression": false, "filter": "true", "output": "default" }, { "name": "my_route", "final": true, "disabled": false, "pipeline": "my_pipeline", "enableOutputExpression": false, "filter": "__inputId == 'syslog:in_syslog_9021:tcp'", "output": "out_s3", "description": "This is my new Route" } ] }' ``` ## Commit and Deploy the Resource Configurations {#commit-deploy-resource-configs} This example demonstrates how to commit and deploy the resource configurations to your Worker Group, then commit to the Leader to keep it in sync with the Worker Group. Committing and deploying the Worker Group configuration requires three requests: commit to the Worker Group, deploy to the Worker Group, and commit the Leader to keep it in sync. First, commit the pending resource configurations to the Worker Group: **Cribl.Cloud and Hybrid** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/version/commit?groupId=my-worker-group" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "message": "Commit resource configurations to my-worker-group" }' ``` **On-Prem** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/version/commit?groupId=my-worker-group" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "message": "Commit resource configurations to my-worker-group" }' ``` Next, deploy the committed changes to the Worker Group. This request includes the `version` body parameter, which uses the value of `commit` from the response body for the commit request: **Cribl.Cloud and Hybrid** ```shell curl --request PATCH \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/products/stream/groups/my-worker-group/deploy" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "version": 1234abcd5678efgh9012ijkl3456mnop7EXAMPLE }' ``` **On-Prem** ```shell curl --request PATCH \ --url "https://${hostname}:${port}/api/v1/products/stream/groups/my-worker-group/deploy" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "version": 1234abcd5678efgh9012ijkl3456mnop7EXAMPLE }' ``` Finally, commit the changes to the Leader to keep the Leader in sync with the Worker Group: **Cribl.Cloud and Hybrid** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/version/commit" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "message": "Sync my-worker-group resource configurations with Leader" } ``` **On-Prem** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/version/commit" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "message": "Sync my-worker-group resource configurations with Leader" } ``` ############################################################ # SOURCE: https://docs.cribl.io/cribl-as-code/update-configurations.md ############################################################ # Update Configurations Use the Cribl API to programmatically update the configuration of supported objects like Sources and Destinations. Use the `/system/inputs` endpoints for Sources and the `/system/outputs` endpoints for Destinations (see the [API Reference](/api-reference/) for details). > ##### About Code Examples > > Code examples use Bearer token authentication. Read the [API authentication documentation](api-auth) to learn how to configure authentication. The API Credential (Cribl.Cloud and hybrid) or login credentials (on-prem) that you use to obtain the Bearer token must have the necessary [Permissions](/iam/permissions) for the operations in code examples. > > Replace the variables in code examples with the corresponding information for your Cribl deployment. > > In Cribl.Cloud Government, use `cribl-gov.cloud` in request URLs instead of `cribl.cloud`. For example, `https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1/m/${groupName}/system/outputs/MinIO_testing`. > > For on-prem deployments, to use `https` in request URLs, you must [Configure TLS](/stream/securing-configure-tls/). > > Code examples do not include all available body parameters. For a complete list of body parameters for specific endpoints, refer to the documentation in the [API Reference](/api-reference). > > In Cribl.Cloud and other distributed deployments, you must [commit and deploy](commit-deploy) the changes you make. > {.box .info} ## Update a Destination Configuration {#update-destination} This example demonstrates how to change the secret key pair that is used to authenticate to an existing MinIO Destination by sending a `PATCH` request to the `/system/outputs/{id}` endpoint. But first, you'll send a `GET` request to retrieve the definition for the Destination. The definition includes the attributes and values you'll need to include in the body of your `PATCH` request. > The `PATCH /system/outputs/{id}` endpoint requires a **complete** representation of the resource that you want to update in the request body. This endpoint does not support partial updates. Cribl removes any omitted fields when updating the resource. > > Also, the body for your `PATCH` request is based on the existing configuration that you [retrieve](#get-destination-definition), so you must confirm that the configuration is correct. If the existing configuration is incorrect, the updated resource may not function as expected. > {.box .warning} ### 1. Retrieve the Definition for the Destination {#get-destination-definition} Retrieve the definition for the Destination that you want to update. After you confirm that the retrieved definition is correct, you'll use it as the basis of your request in the next step, changing only the values that you want to update. In this example, the Destination ID is `MinIO_testing`. **Cribl.Cloud and Hybrid** ```shell curl --request GET \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/${groupName}/system/outputs/MinIO_testing" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" ``` **On-Prem (Single-Instance)** ```shell curl --request GET \ --url "https://${hostname}:${port}/api/v1/system/outputs/MinIO_testing" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" ``` **On-Prem (Distributed)** ```shell curl --request GET \ --url "https://${hostname}:${port}/api/v1/m/${groupName}/system/outputs/MinIO_testing" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" ``` The response includes the definition of the `MinIO_testing` Destination as a JSON object: ```json { "items": [ { "id": "MinIO_testing", "systemFields": [ "cribl_pipe" ], "streamtags": [], "awsAuthenticationMethod": "secret", "stagePath": "$CRIBL_HOME/state/outputs/testing", "addIdToStagePath": true, "signatureVersion": "v4", "objectACL": "private", "reuseConnections": true, "rejectUnauthorized": true, "verifyPermissions": true, "removeEmptyDirs": true, "partitionExpr": "C.Time.strftime(_time ? _time : Date.now()/1000, '%Y/%m/%d')", "format": "json", "baseFileName": "`CriblOut`", "fileNameSuffix": "`.${C.env[\"CRIBL_WORKER_ID\"]}.${__format}${__compression === \"gzip\" ? \".gz\" : \"\"}`", "maxFileSizeMB": 32, "maxOpenFiles": 100, "headerLine": "", "writeHighWaterMark": 64, "onBackpressure": "block", "deadletterEnabled": false, "onDiskFullBackpressure": "block", "maxFileOpenTimeSec": 300, "maxFileIdleTimeSec": 30, "maxConcurrentFileParts": 4, "compress": "gzip", "compressionLevel": "best_speed", "emptyDirCleanupSec": 300, "type": "minio", "endpoint": "http://minio:9090", "bucket": "test", "awsSecret": "MinIO_testing_minio_secret_keypair", "status": { "health": "Green", "timestamp": 1742219848827, "metrics": { "openFileStreams": 0, "sentCount": 0, "bytesWritten": 0 } }, "notifications": [] } ], "count": 1 } ``` ### 2. Update the Destination Configuration {#update-destination-config} Use the response to the `GET /system/outputs/{id}` request from the previous step as the request body, with the following changes: - Do not include the `items` array or the `count` attribute from the `GET` response. - Replace the value for the `awsSecret` parameter with the name of the secret key pair that you want to use for the Destination. > Do not omit any fields from the resource representation in the request body. Include a complete representation of the resource, replacing only the values for the fields that you want to update. Cribl removes any omitted fields when updating the resource. > {.box .info} **Cribl.Cloud and Hybrid** ```shell curl --request PATCH \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/${groupName}/system/outputs/MinIO_testing" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "MinIO_testing", "systemFields": [ "cribl_pipe" ], "streamtags": [], "awsAuthenticationMethod": "secret", "stagePath": "$CRIBL_HOME/state/outputs/testing", "addIdToStagePath": true, "signatureVersion": "v4", "objectACL": "private", "reuseConnections": true, "rejectUnauthorized": true, "verifyPermissions": true, "removeEmptyDirs": true, "partitionExpr": "C.Time.strftime(_time ? _time : Date.now()/1000, '%Y/%m/%d')", "format": "json", "baseFileName": "`CriblOut`", "fileNameSuffix": "`.${C.env[\"CRIBL_WORKER_ID\"]}.${__format}${__compression === \"gzip\" ? \".gz\" : \"\"}`", "maxFileSizeMB": 32, "maxOpenFiles": 100, "headerLine": "", "writeHighWaterMark": 64, "onBackpressure": "block", "deadletterEnabled": false, "onDiskFullBackpressure": "block", "maxFileOpenTimeSec": 300, "maxFileIdleTimeSec": 30, "maxConcurrentFileParts": 4, "compress": "gzip", "compressionLevel": "best_speed", "emptyDirCleanupSec": 300, "type": "minio", "endpoint": "http://minio:9090", "bucket": "test", "awsSecret": "MinIO_new_minio_secret_keypair", "status": { "health": "Green", "timestamp": 1742222265527, "metrics": { "openFileStreams": 0, "sentCount": 0, "bytesWritten": 0 } }, "notifications": [] }' ``` **On-Prem (Single-Instance)** ```shell curl --request PATCH \ --url "https://${hostname}:${port}/api/v1/system/outputs/MinIO_testing" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "MinIO_testing", "systemFields": [ "cribl_pipe" ], "streamtags": [], "awsAuthenticationMethod": "secret", "stagePath": "$CRIBL_HOME/state/outputs/testing", "addIdToStagePath": true, "signatureVersion": "v4", "objectACL": "private", "reuseConnections": true, "rejectUnauthorized": true, "verifyPermissions": true, "removeEmptyDirs": true, "partitionExpr": "C.Time.strftime(_time ? _time : Date.now()/1000, '%Y/%m/%d')", "format": "json", "baseFileName": "`CriblOut`", "fileNameSuffix": "`.${C.env[\"CRIBL_WORKER_ID\"]}.${__format}${__compression === \"gzip\" ? \".gz\" : \"\"}`", "maxFileSizeMB": 32, "maxOpenFiles": 100, "headerLine": "", "writeHighWaterMark": 64, "onBackpressure": "block", "deadletterEnabled": false, "onDiskFullBackpressure": "block", "maxFileOpenTimeSec": 300, "maxFileIdleTimeSec": 30, "maxConcurrentFileParts": 4, "compress": "gzip", "compressionLevel": "best_speed", "emptyDirCleanupSec": 300, "type": "minio", "endpoint": "http://minio:9090", "bucket": "test", "awsSecret": "MinIO_new_minio_secret_keypair", "status": { "health": "Green", "timestamp": 1742222265527, "metrics": { "openFileStreams": 0, "sentCount": 0, "bytesWritten": 0 } }, "notifications": [] }' ``` **On-Prem (Distributed)** ```shell curl --request PATCH \ --url "https://${hostname}:${port}/api/v1/m/${groupName}/system/outputs/MinIO_testing" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "MinIO_testing", "systemFields": [ "cribl_pipe" ], "streamtags": [], "awsAuthenticationMethod": "secret", "stagePath": "$CRIBL_HOME/state/outputs/testing", "addIdToStagePath": true, "signatureVersion": "v4", "objectACL": "private", "reuseConnections": true, "rejectUnauthorized": true, "verifyPermissions": true, "removeEmptyDirs": true, "partitionExpr": "C.Time.strftime(_time ? _time : Date.now()/1000, '%Y/%m/%d')", "format": "json", "baseFileName": "`CriblOut`", "fileNameSuffix": "`.${C.env[\"CRIBL_WORKER_ID\"]}.${__format}${__compression === \"gzip\" ? \".gz\" : \"\"}`", "maxFileSizeMB": 32, "maxOpenFiles": 100, "headerLine": "", "writeHighWaterMark": 64, "onBackpressure": "block", "deadletterEnabled": false, "onDiskFullBackpressure": "block", "maxFileOpenTimeSec": 300, "maxFileIdleTimeSec": 30, "maxConcurrentFileParts": 4, "compress": "gzip", "compressionLevel": "best_speed", "emptyDirCleanupSec": 300, "type": "minio", "endpoint": "http://minio:9090", "bucket": "test", "awsSecret": "MinIO_new_minio_secret_keypair", "status": { "health": "Green", "timestamp": 1742222265527, "metrics": { "openFileStreams": 0, "sentCount": 0, "bytesWritten": 0 } }, "notifications": [] }' ``` The response includes the definition of the `MinIO_testing` Destination with the updated `awsSecret` value: ```json { "items": [ { "id": "MinIO_testing", "systemFields": [ "cribl_pipe" ], "streamtags": [], "awsAuthenticationMethod": "secret", "stagePath": "$CRIBL_HOME/state/outputs/testing", "addIdToStagePath": true, "signatureVersion": "v4", "objectACL": "private", "reuseConnections": true, "rejectUnauthorized": true, "verifyPermissions": true, "removeEmptyDirs": true, "partitionExpr": "C.Time.strftime(_time ? _time : Date.now()/1000, '%Y/%m/%d')", "format": "json", "baseFileName": "`CriblOut`", "fileNameSuffix": "`.${C.env[\"CRIBL_WORKER_ID\"]}.${__format}${__compression === \"gzip\" ? \".gz\" : \"\"}`", "maxFileSizeMB": 32, "maxOpenFiles": 100, "headerLine": "", "writeHighWaterMark": 64, "onBackpressure": "block", "deadletterEnabled": false, "onDiskFullBackpressure": "block", "maxFileOpenTimeSec": 300, "maxFileIdleTimeSec": 30, "maxConcurrentFileParts": 4, "compress": "gzip", "compressionLevel": "best_speed", "emptyDirCleanupSec": 300, "type": "minio", "endpoint": "http://minio:9090", "bucket": "test", "awsSecret": "MinIO_new_minio_secret_keypair", "notifications": [], "status": { "health": "Green", "timestamp": 1742223031723, "metrics": { "openFileStreams": 0, "sentCount": 0, "bytesWritten": 0 } } } ], "count": 1 } ``` ############################################################ # SOURCE: https://docs.cribl.io/cribl-as-code/copy-export-install-packs.md ############################################################ # Copy, Export, and Install Packs You can use the Cribl API to automate Pack operations, such as in a CI/CD pipeline, like [copying Packs](#copy-packs) between Worker Groups or Fleets and [exporting and installing Packs](#export-install-pack) from one Worker Group or Fleet to another. > ##### About Code Examples > > Code examples use Bearer token authentication. Read the [API authentication documentation](api-auth) to learn how to configure authentication. The API Credential (Cribl.Cloud and hybrid) or login credentials (on-prem) that you use to obtain the Bearer token must have the necessary [Permissions](/iam/permissions) for the operations in code examples. > > Replace the variables in code examples with the corresponding information for your Cribl deployment. > > In Cribl.Cloud Government, use `cribl-gov.cloud` in request URLs instead of `cribl.cloud`. For example, `https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1/packs/__clone__`. > > For on-prem deployments, to use `https` in request URLs, you must [Configure TLS](/stream/securing-configure-tls/). > > Code examples do not include all available body parameters. For a complete list of body parameters for specific endpoints, refer to the documentation in the [API Reference](/api-reference). > > In Cribl.Cloud and other distributed deployments, you must [commit and deploy](commit-deploy) the changes you make. > {.box .info} ## Copy Packs {#copy-packs} The Cribl API includes a `/packs/__clone__` endpoint for copying Packs from a Worker Group to one or more other Worker Groups. The following example demonstrates how to copy two Packs from the `default` Worker Group to the `newHerd` and `goatMob` Worker Groups. Provide the following values in the request body: * `srcGroup`: ID of the Worker Group that contains the Packs you want to copy. * `dstGroups`: Array of IDs of the target Worker Groups where you want to install the copied Packs. * `packs`: Array of IDs of the Packs you want to copy. **Cribl.Cloud and Hybrid** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/packs/__clone__" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "srcGroup": "default", "dstGroups": [ "newHerd", "goatMob" ], "packs": [ "cribl-palo-alto-networks", "cribl-cisco-asa-cleanup" ] }' ``` **On-Prem** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/packs/__clone__" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "source": "goatherd.a12b3Cd.crbl", "id": "billyPack" }' ``` The response is a JSON object that confirms the target Worker Groups where the copied Packs are installed, similar to this example: ```json { "installed": [ { "group": "newHerd" }, { "group": "goatMob" } ] } ``` If you copy Packs to only one Worker Group, the response includes details about the installed packs instead of the Worker Group, similar to this example: ```json { "installed": [ { "id": "cribl-palo-alto-networks", "source": "file:/opt/cribl/state/packs/cribl-palo-alto-networks.ABC12d3.tmp.crbl", "version": "1.1.2", "group": "defaultHybrid", "warnings": [] }, { "id": "cribl-cisco-asa-cleanup", "source": "file:/opt/cribl/state/packs/cribl-cisco-asa-cleanup.eF4G567.tmp.crbl", "version": "1.1.15", "warnings": [] } ] } ``` ## Export and Install a Pack {#export-install-pack} The following example demonstrates how to export a Pack from one Worker Group or Fleet and upload and install the Pack in another. The two Worker Groups or Fleets do **not** need to have the same Leader Node. ### 1. Export the Pack {#export-pack} The request URL should use the name of the Worker Group or Fleet from which you are exporting (in this example, `originalHerd`). Include the `mode` query parameter in the request URL to specify the [export mode](/stream/packs/#export-mode) you want to use. The request returns an octet-stream attachment that downloads as a `.crbl` file. This example uses the `>` redirect to write the exported Pack to a specific file (in this case, `goatherd.crbl`). If you do not include a redirect to specify a file name, Cribl downloads the Pack to a file that is named after the Pack ID in the format `${packName}.crbl`. **Cribl.Cloud and Hybrid** ```shell curl --request GET \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/originalHerd/packs/${packName}/export?mode=${exportMode}' > goatherd.crbl \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" ``` **On-Prem** ```shell curl --request GET \ --url "https://${hostname}:${port}/api/v1/m/originalHerd/packs/${packName}/export?mode=${exportMode}' > goatherd.crbl \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" ``` ### 2. Upload the Exported Pack to the Target Worker Group or Fleet {#upload-exported-pack} In the request URL, make sure to use the name of the target Worker Group or Fleet (in this example, `newHerd`). Include the `filename` query parameter in the request URL to specify the file name of the exported Pack. Note the values for the custom headers `Accept-Encoding`, `Connection`, and `Content-Type`. **Cribl.Cloud and Hybrid** ```shell curl --request PUT \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/newHerd/packs?filename=goatherd.crbl" \ --header "Authorization: Bearer ${token}" \ --header "Accept-Encoding: gzip, deflate, br, zst" \ --header "Connection: keep-alive" \ --header "Content-Type: application/octet-stream" \ --data-binary '@goatherd.crbl' ``` **On-Prem** ```shell curl --request PUT \ --url "https://${hostname}:${port}/api/v1/m/newHerd/packs?filename=goatherd.crbl" \ --header "Authorization: Bearer ${token}" \ --header "Accept-Encoding: gzip, deflate, br, zst" \ --header "Connection: keep-alive" \ --header "Content-Type: application/octet-stream" \ --data-binary '@goatherd.crbl' ``` The response is a JSON object that includes the Pack name, a random ID, and the `crbl` file extension, similar to this example: ```json {"source":"goatherd.a12b3Cd.crbl"} ``` ### 3. Install the Uploaded Pack in the Target Worker Group or Fleet {#install-uploaded-pack} The request body must include the JSON object from the response to the upload request in the previous step. If you want to rename the Pack in the target Worker Group or Fleet, add the `id` parameter in the request body as shown in this example. **Cribl.Cloud and Hybrid** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/newHerd/packs" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "source": "goatherd.a12b3Cd.crbl", "id": "billyPack" }' ``` **On-Prem** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/m/newHerd/packs" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "source": "goatherd.a12b3Cd.crbl", "id": "billyPack" }' ``` The response is a JSON object that provides information about the installed Pack, similar to this example: ```json { "items": [ { "id": "billyPack", "source": "file:/opt/cribl/state/packs/goatherd.a12b3Cd.crbl", "version": "0.0.1", "warnings": [] } ], "count": 1 } ``` ## Install a Pack from a Git Repository {#install-git-pack} If a Pack is hosted in a Git repository, you can install it directly from the repository. In the request body, prepend `git+` to the repository URL in the `source` parameter value. Use the `spec` parameter to specify the Git branch to install from. If you omit `spec`, Cribl uses the repository's default branch. The following example installs a Pack from the `main` branch of the specified GitHub repository and uses the `id` parameter to rename the Pack in the target Worker Group or Fleet. **Cribl.Cloud and Hybrid** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/newHerd/packs" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "source": "git+https://github.com/criblio/cribl_ocsf_postprocessing", "spec": "main", "id": "my-ocsf-pack" }' ``` **On-Prem** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/m/newHerd/packs" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "source": "git+https://github.com/criblio/cribl_ocsf_postprocessing", "spec": "main", "id": "my-ocsf-pack" }' ``` ############################################################ # SOURCE: https://docs.cribl.io/cribl-as-code/create-update-lookups.md ############################################################ # Create and Update Lookups [Lookups](/stream/lookups-about/) provide a flexible way to enrich events en route to their Destinations. This topic demonstrates how to use the Cribl API to get a list of lookups and create and replace lookups. > ##### About Code Examples > > Code examples use Bearer token authentication. Read the [API authentication documentation](api-auth) to learn how to configure authentication. The API Credential (Cribl.Cloud and hybrid) or login credentials (on-prem) that you use to obtain the Bearer token must have the necessary [Permissions](/iam/permissions) for the operations in code examples. > > Replace the variables in code examples with the corresponding information for your Cribl deployment. > > In Cribl.Cloud Government, use `cribl-gov.cloud` in request URLs instead of `cribl.cloud`. For example, `https://${workspaceName}-${organizationId}.cribl-gov.cloud/api/v1/m/${groupName}/system/lookups`. > > For on-prem deployments, to use `https` in request URLs, you must [Configure TLS](/stream/securing-configure-tls/). > > Code examples do not include all available body parameters. For a complete list of body parameters for specific endpoints, refer to the documentation in the [API Reference](/api-reference). > > In Cribl.Cloud and other distributed deployments, you must [commit and deploy](commit-deploy) the changes you make. > {.box .info} ## Get Existing Lookups {#get-lookups} Before creating or updating lookups, send a `GET` request to the `/system/lookups` endpoint to retrieve a list of existing lookups. Getting a list of existing lookups is helpful for validating data and streamlining subsequent requests. For example, checking whether a lookup already exists helps you avoid errors due to sending a request to create a duplicate lookup. **Cribl.Cloud and Hybrid** ```shell curl --request GET \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/${groupName}/system/lookups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" ``` **On-Prem (Single-Instance)** ```shell curl --request GET \ --url "https://${hostname}:${port}/api/v1/system/lookups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" ``` **On-Prem (Distributed)** ```shell curl --request GET \ --url "https://${hostname}:${port}/api/v1/m/${groupName}/system/lookups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" ``` The response is a JSON object that includes lookup file names and sizes, along with available information like modes, number of rows, descriptions, tags, and random version numbers for each lookup. The response also includes the total number of lookups, similar to this example: ```json {"items":[{"id":"host_destinations.csv","size":77824,"mode":"disk","description":"Host destination lookups","tags": "destinations","rows":935,"version":"56eFG5H6"},{"id":"service_names_port_numbers.csv","size":25146},{"id":"name_vendor_products.csv","size":6002}],"count":3} ``` ## Create a Lookup {#create-lookup} Follow these steps to use the Cribl API to create a lookup. ### 1. Upload the Lookup File {#upload-lookup-file} Include the `filename` query parameter in the request URL to specify the name of the lookup file you want to use (in this example, `lookupExample.csv`). The value for the custom header `Content-Type` is `text/csv`. **Cribl.Cloud and Hybrid** ```shell curl --request PUT \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/${groupName}/system/lookups?filename=lookupExample.csv" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: text/csv" \ --data-binary '@${/path/to/file/lookupExample.csv}' ``` **On-Prem (Single-Instance)** ```shell curl --request PUT \ --url "https://${hostname}:${port}/api/v1/system/lookups?filename=lookupExample.csv" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: text/csv" \ --data-binary '@${/path/to/file/lookupExample.csv}' ``` **On-Prem (Distributed)** ```shell curl --request PUT \ --url "https://${hostname}:${port}/api/v1/m/${groupName}/system/lookups?filename=lookupExample.csv" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: text/csv" \ --data-binary '@${/path/to/file/lookupExample.csv}' ``` The response is a JSON object that includes the lookup file name with a random ID and information about the file's number of rows and size, similar to this example: ```json {"filename":"lookupExample.csv.ABCDeFg.tmp","rows":1433,"size":23014} ``` ### 2. Create the Lookup {#create-lookup-from-upload} Send a `POST` request to the `/system/lookups` endpoint to create the lookup from the uploaded file. Provide the following values in the request body: * `id`: File name to use for the lookup. * `fileInfo.filename`: Value of the `filename` attribute from the response to the upload request in the previous step. This example creates a lookup that uses [in-memory file storage](/stream/lookups-about#storage-mode), which is the default. **Cribl.Cloud and Hybrid** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/${groupName}/system/lookups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "newLookup", "fileInfo": { "filename": "lookupExample.csv.ABCDeFg.tmp" } }' ``` **On-Prem (Single-Instance)** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/system/lookups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "newLookup", "fileInfo": { "filename": "lookupExample.csv.ABCDeFg.tmp" } }' ``` **On-Prem (Distributed)** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/m/${groupName}/system/lookups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "newLookup", "fileInfo": { "filename": "lookupExample.csv.ABCDeFg.tmp" } }' ``` The response is a JSON object that includes the lookup file name, a random version for the lookup, and the lookup size, similar to this example: ```json {"items":[{"id":"newLookup.csv","version":"12AbC3D4","size":23014}],"count":1} ``` To create a lookup that uses [disk-based file storage](/stream/lookups-about#storage-mode), include `"mode": "disk"` in the request body as follows: **Cribl.Cloud and Hybrid** ```shell curl --request POST \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/${groupName}/system/lookups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "newLookup", "fileInfo": { "filename": "lookupExample.csv.ABCDeFg.tmp" }, "mode": "disk" }' ``` **On-Prem (Single-Instance)** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/system/lookups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "newLookup", "fileInfo": { "filename": "lookupExample.csv.ABCDeFg.tmp" }, "mode": "disk" }' ``` **On-Prem (Distributed)** ```shell curl --request POST \ --url "https://${hostname}:${port}/api/v1/m/${groupName}/system/lookups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "newLookup", "fileInfo": { "filename": "lookupExample.csv.ABCDeFg.tmp" }, "mode": "disk" }' ``` For disk-based lookups, the response includes `mode` and `pendingTask`, similar to this example: ```json {"items":[{"id":"newLookup.csv","mode":"disk","version":"12AbC3D4","pendingTask":{"id":"GuPdiPM8","type":"IMPORT"},"size":23014}],"count":1} ``` Read [Choose a Lookup File Storage Mode](/stream/lookups-about/#storage-mode) for more information about in-memory and disk-based lookups. ## Replace an Existing In-Memory Lookup {#replace-lookup} > This example replaces an in-memory lookup. For an example that replaces a disk-based lookup, see [Deploy Modified Disk-Based Lookups](#deploy-modified-lookup-files). For more information about the lookup modes, read [Choose a Lookup File Storage Mode](/stream/lookups-about/#storage-mode). {.box .info} To replace an existing in-memory lookup, first upload the new lookup file as described in step 1 of the [Create a Lookup](#create-lookup) instructions. Then, send a `PATCH` request to the `/system/lookups/{id}` endpoint. In the request URL, replace `{id}` with the file name of the lookup you want to replace. Provide the following values in the request body: * `id`: Value of the `id` attribute for the lookup, which you can get from the response to a request to [get existing lookups](#get-lookups). * `fileInfo.filename`: Value of the `filename` attribute from the response to the [upload request](#upload-lookup-file). In this example, the existing lookup is `newLookup.csv` and the `filename` value is `lookupUpdate.csv.1234aBcD.tmp`. **Cribl.Cloud and Hybrid** ```shell curl --request PATCH \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/${groupName}/system/lookups/newLookup.csv" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "newLookup.csv", "fileInfo": { "filename": "lookupUpdate.csv.1234aBcD.tmp" } }' ``` **On-Prem (Single-Instance)** ```shell curl --request PATCH \ --url "https://${hostname}:${port}/api/v1/system/lookups/newLookup.csv" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "newLookup.csv", "fileInfo": { "filename": "lookupUpdate.csv.1234aBcD.tmp" } }' ``` **On-Prem (Distributed)** ```shell curl --request PATCH \ --url "https://${hostname}:${port}/api/v1/m/${groupName}/system/lookups/newLookup.csv" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" \ --data '{ "id": "newLookup.csv", "fileInfo": { "filename": "lookupUpdate.csv.1234aBcD.tmp" } }' ``` The response is a JSON object that includes the lookup file name, a random version for the lookup, and the lookup size, similar to this example: ```json {"items":[{"id":"newLookup.csv","version":"Xyz56789","size":200}],"count":1} ``` ## Deploy Modified Disk-Based Lookups {#deploy-modified-lookup-files} > This example deploys a modified disk-based lookup. For an example that replaces an in-memory lookup, see [Replace an Existing In-Memory Lookup](#replace-lookup). For more information about the lookup modes, read [Choose a Lookup File Storage Mode](/stream/lookups-about/#storage-mode). {.box .info} Manual updates are impractical for frequently modified disk-based lookup files. Instead, configure a workflow with the Cribl API to deploy modified lookup files to a Worker Group. You can deploy only the modified lookup file so that the updated data is accessible without restarting any Workers. When deploying lookup updates, remember that each deploy request must specify all lookups intended for the Workers. For example, if you initially deployed lookups A (version a1), B (version b1), and C (version c1), all three reside on the Workers. To update to a modified lookup C (version c2), the deploy request must include A (a1), B (b1), and C (c2). Omitting A and B in the update request for C (c2) will result in the Workers having only lookup C. In Distributed environments, we recommend updating the lookup file only on the Leader Node. The Leader then notifies Worker Nodes that a new configuration is available, and Worker Nodes pull the new configuration from the Leader Node. This example uses the following sequence of requests to Cribl API endpoints: 1. `GET /system/lookups` to [get a list of lookups](#confirm-lookup) to confirm that the lookup that you want to update exists. 2. `GET /system/lookups/{id}/content?raw=1` to [download the lookup file](#download-lookup) so that you can modify it. 3. `PUT /system/lookups?filename={id}` to [upload the modified lookup file](#upload-modified-lookup). 4. `PATCH /system/lookups/{id}` to [replace the existing lookup file](#replace-existing-lookup) with the modified version. 5. `GET /master/groups/{groupName}` to [get information](#get-info-modified-lookup) about the modified lookup file. 6. `PATCH /master/groups/{groupName}/deploy` to [selectively deploy the modified lookup file](#deploy-modified-lookup). The modified lookup file will propagate to the Worker Nodes that belong to the Worker Group. ### 1. Confirm that the Lookup Exists {#confirm-lookup} To prevent errors, get a list of the lookups that exist on the Worker Group so that you can confirm that the lookup that you want to modify is included. **Cribl.Cloud and Hybrid** ```shell curl --request GET \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/default/system/lookups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" ``` **On-Prem (Distributed)** ```shell curl --request GET \ --url "https://${hostname}:${port}/api/v1/m/default/system/lookups" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: application/json" ``` The response is a JSON object that lists the lookups, similar to this example: ```json {"items":[{"id":"newLookup.csv","size":23014,"version":"12AbC3D4"},{"id":"host_destinations.csv","size":77824,"mode":"disk","version":"56eFG5H6","rows":935,"indices":[{"fields":["service_name"],"caseSensitive":true}]},{"id":"service_names_port_numbers.csv","size":25146},{"id":"name_vendor_products.csv","size":6002}],"count":4} ``` This example uses the `host_destinations.csv` lookup, which is included in the list of lookups for the `default` Worker Group. ### 2. Download the Lookup File {#download-lookup} Download the lookup file so that you can modify it locally. **Cribl.Cloud and Hybrid** ```shell curl --request GET \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/default/system/lookups/host_destinations.csv/content?raw=1" \ --header "Authorization: Bearer ${token}" \ --output 'host_destinations.csv' ``` **On-Prem (Distributed)** ```shell curl --request GET \ --url "https://${hostname}:${port}/api/v1/m/default/system/lookups/host_destinations.csv/content?raw=1" \ --header "Authorization: Bearer ${token}" \ --output 'host_destinations.csv' ``` The client initiates a download of the lookup file. You may see a prompt to save the file, or the file may automatically download to a specified location, depending on your local browser settings. ### 3. Upload the Modified Lookup File {#upload-modified-lookup} After you modify the lookup file, upload it from its current location on the local machine. In this example, the lookup file `host_destinations.csv` is stored in the `/opt` directory. **Cribl.Cloud and Hybrid** ```shell curl --request PUT \ --url "https://${workspaceName}-${organizationId}.cribl.cloud/api/v1/m/default/system/lookups?filename=host_destinations.csv" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: text/csv" \ --data-binary '@/opt/host_destinations.csv' ``` **On-Prem (Distributed)** ```shell curl --request PUT \ --url "https://${hostname}:${port}/api/v1/m/default/system/lookups?filename=host_destinations.csv" \ --header "Authorization: Bearer ${token}" \ --header "Content-Type: text/csv" \ --data-binary '@/opt/host_destinations.csv' ``` The response is a JSON object that includes the lookup file name with a random ID and information about the file's number of rows and size, similar to this example: ```json {"filename":"host_destinations.csv.ABCDeFg.tmp","rows":935,"size":77824} ``` ### 4. Replace the Existing Lookup File {#replace-existing-lookup} Replace the existing lookup file on the Worker Group with the modified lookup file that you uploaded. In the request URL, replace `{id}` with the file name of the lookup you're modifying. Provide the following values in the request body: * `id`: Value of the `id` attribute for the lookup from the response to the [confirm request in step 1](#confirm-lookup). * `fileInfo.filename`: Value of the `filename` attribute from the response to the [upload request in step 3](#upload-modified-lookup). * `mode`: The type of lookup (in this example, `disk`). **Cribl.Cloud and Hybrid** ```shell curl --re
[...]
